﻿Imports System.Windows.Data
Imports System.Collections.ObjectModel
Imports C1.Silverlight.DataGrid.Excel

Partial Public Class MainPage
    Inherits UserControl

    Public Sub New()
        InitializeComponent()
        Me.DataContext = New NameList()
    End Sub

    Private Sub Button_Click(sender As System.Object, e As System.Windows.RoutedEventArgs)
        Dim options As New ExcelSaveOptions()
        options.FileFormat = ExcelFileFormat.Xlsx
        options.KeepColumnWidths = True
        options.KeepRowHeights = True
        options.CollapsibleGroups = True


        Dim excelExt = options.FileFormat.ToString()

        Dim dialog As New System.Windows.Controls.SaveFileDialog()
        dialog.DefaultExt = "*." & Convert.ToString(excelExt)
        dialog.Filter = "Excel " & Convert.ToString(excelExt) & " (*." & Convert.ToString(excelExt) & ")|*." & Convert.ToString(excelExt) & "|All files (*.*)|*.*"

        If dialog.ShowDialog() = False Then
            Return
        End If

        Using stream = dialog.OpenFile()
            _dataGrid.Save(stream, options)
        End Using

    End Sub

    Private Sub DataGridTemplateColumn_GettingCellValue(sender As System.Object, e As C1.Silverlight.DataGrid.DataGridGettingCellValueEventArgs)

        e.Value = CType(e.Row.Presenter(_dataGrid.Columns(4)).Content, TextBlock).Text
    End Sub
End Class

Public Class NameList
    Inherits ObservableCollection(Of PersonName)
    Public Sub New()
        MyBase.New()
        For i As Integer = 1 To 199
            Add(New PersonName("Fname" & i.ToString(), "Lname" & i.ToString()))
        Next
    End Sub
End Class


Public Class PersonName

    Private m_firstName As String
    Private m_lastName As String
    Private _check As Boolean

    Public Sub New(first As String, last As String)
        Me.m_firstName = first
        Me.m_lastName = last
        Me._check = False
    End Sub

    Public Property Checked() As Boolean
        Get
            Return _check
        End Get
        Set(value As Boolean)
            _check = value
        End Set
    End Property

    Public Property FirstName() As String
        Get
            Return m_firstName
        End Get
        Set(value As String)
            m_firstName = value
        End Set
    End Property

    Public Property LastName() As String
        Get
            Return m_lastName
        End Get
        Set(value As String)
            m_lastName = value
        End Set
    End Property
End Class

Public Class BoolTextConverter
    Implements IValueConverter

    Public Function Convert(value As Object, targetType As System.Type, parameter As Object, culture As System.Globalization.CultureInfo) As Object Implements System.Windows.Data.IValueConverter.Convert
        If value.ToString() = "False" Then
            Return "No"
        Else
            Return "Yes"
        End If
    End Function

    Public Function ConvertBack(value As Object, targetType As System.Type, parameter As Object, culture As System.Globalization.CultureInfo) As Object Implements System.Windows.Data.IValueConverter.ConvertBack
        Return value
    End Function
End Class
